%define svn_date 20141114
%define svn_revision 4598
%global checkout %{svn_date}svn%{svn_revision}

Name:           wsprx
Version:        0.9
Release:        0.1.%{checkout}%{?dist}
Summary:        Weak-signal communications between amateur radio operators
License:        BSD
Group:          Applications/Engineering
URL:            http://sourceforge.net/projects/wsjt/
# Upstream did not provide release tarballs at the time of this writing.
# The source tarball was generated from the SVN repo with these commands:
#  svn co -r %{svn_revision} \
#      svn://svn.code.sf.net/p/wsjt/wsjt/branches/wsprx wsprx-%{checkout}
#  rm -rf wsprx-%{checkout}/.svn \
#         wsprx-%{checkout}/*.{a,dll} \
#         wsprx-%{checkout}/lib/*.{a,dll}
#  tar cvjf wsprx-%{checkout}.tar.bz2 wsprx-%{checkout}
Source:         %{name}-%{checkout}.tar.bz2
Patch:          %{name}-makefile.patch
BuildRequires:  portaudio-devel, qt5-qtbase-devel

%description
The wsprx application (or Experimental Weak Signal Propagation Reporter)
is designed for weak-signal communications between amateur radio operators
for the purposes of active probing of propagation conditions on the mid
and high frequency bands. The program has a feature that allows stations
with internet access to automatically upload their reception reports to
a central database called WSPRnet, which includes a mapping facility.
The reception data is available to the general public through the web
site: http://wsprnet.org/

The transmissions typically use very low (QRP/QRPp) power and contain
the station's callsign, maidenhead grid locator, and transmit power in
dBm. The wsprx program supports both the original WSPR-2 and experimental
WSPR-15 protocols, which produce transmissions of approximately two and
fifteen minutes in duration respectively.

The WSPR-2 protocol compresses the information into 50 binary digits,
which are then encoded using a convolutional code with constraint length
K=32 and a rate of r=1/2. The modulation is continuous phase 4-FSK,
which occupies slightly less that 6 Hz of total bandwidth.

%prep
%setup -n %{name}-%{checkout} -q
%patch -p1 -b .orig

%build
# Build the static library (which the applications link to, but isn't packaged)
cd lib
make -f Makefile.linux OPT_FLAGS+="-g ${RPM_OPT_FLAGS}" clean
make -f Makefile.linux OPT_FLAGS+="-g ${RPM_OPT_FLAGS}"
cd ..
# Generate the Makefile using qmake (this project uses Qt5)
%{_qt5_qmake} %{name}.pro
# Build the wsprx application
make OPT_FLAGS="-g ${RPM_OPT_FLAGS}" clean
make OPT_FLAGS="-g ${RPM_OPT_FLAGS}"

%install
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
# The Makefiles have no install target, so we install the executables manually
install -m 0755 %{name}      ${RPM_BUILD_ROOT}%{_bindir}/
install -m 0755 lib/WSPRcode ${RPM_BUILD_ROOT}%{_bindir}/
install -m 0755 lib/wsprd    ${RPM_BUILD_ROOT}%{_bindir}/
# Rename the license file to conform with defacto standards
cp -p LICENSE_WHEATLEY.TXT LICENSE

%files
%doc LICENSE
%{_bindir}/%{name}
%{_bindir}/WSPRcode
%{_bindir}/wsprd

%changelog
* Sun Nov 23 2014 John C. Peterson <jcp@eskimo.com> - 0.9-1
- Initial spec file.

